Ring-Stem Mark in JavaScript

Using ApexCharts with JavaScript

This Ring-Stem Mark example uses ApexCharts.js directly in JavaScript, with no wrapper component.

Install it with npm install apexcharts, then mount the chart with new ApexCharts(element, options).render().

JavaScript installation guide
// Marks (#11): register a reusable "ringStem" series type once. Each datum is
// a { x, y: [start, end] } pair. dataType 'rangeXY' tells ApexCharts to fold
// BOTH y-bounds into the axis scale (so the axis fits the full range, not just
// the end value) and to render the tooltip as "start - end".
//
// ApexCharts ships `chart.type: 'dumbbell'` for the ordinary version of this
// chart. What a custom type buys you is the mark itself: a hollow ring for
// where the value started and a filled dot for where it finished.
ApexCharts.registerSeriesType('ringStem', {
  dataType: 'rangeXY',
  renderItem: function (ctx) {
    var datum = ctx.datum
    var x = ctx.x
    var scales = ctx.scales
    var api = ctx.api
    var yStart = scales.y(datum.y[0])
    var yEnd = scales.y(datum.y[1])
    // connecting stem
    api.line({
      x1: x,
      y1: yStart,
      x2: x,
      y2: yEnd,
      stroke: '#d0d5dd',
      width: 4,
      lineCap: 'round',
    })
    // start marker (hollow ring) and end marker (filled)
    api.circle({
      cx: x,
      cy: yStart,
      r: 7,
      fill: '#fff',
      stroke: '#008FFB',
      strokeWidth: 3,
    })
    api.circle({ cx: x, cy: yEnd, r: 7, fill: '#00B894' })
  },
})

var ringStemData = [
  { x: 'Austin', y: [312, 498] },
  { x: 'Denver', y: [398, 545] },
  { x: 'Miami', y: [285, 610] },
  { x: 'Seattle', y: [512, 720] },
  { x: 'Boise', y: [255, 415] },
  { x: 'Raleigh', y: [268, 402] },
  { x: 'Phoenix', y: [295, 468] },
]

var options = {
  series: [{ name: 'Price range', data: ringStemData }],
  chart: {
    height: 440,
    type: 'ringStem',
    animations: { enabled: false },
    toolbar: { show: false },
  },
  grid: {
    padding: { left: 15, right: 15 },
    xaxis: { lines: { show: true } },
  },
  title: {
    text: 'Median home price by city: 2019 vs 2024',
    align: 'left',
  },
  subtitle: {
    text: 'A custom "ringStem" series type built with Marks (registerSeriesType)',
    align: 'left',
  },
  xaxis: {
    type: 'category',
    tooltip: { enabled: false },
  },
  yaxis: {
    min: 200,
    tickAmount: 6,
    labels: {
      formatter: function (val) {
        return '$' + Math.round(val) + 'k'
      },
    },
  },
  tooltip: {
    y: {
      formatter: function (val) {
        return '$' + val + 'k'
      },
    },
  },
}

var chart = new ApexCharts(document.querySelector('#chart'), options)
chart.render()

Ring-Stem Mark in Vue

Using ApexCharts with Vue

This Ring-Stem Mark example wires ApexCharts into Vue through the vue3-apexcharts component.

Install it with npm install vue3-apexcharts apexcharts, then mount the chart with <apexchart type="..." :options="options" :series="series" />.

Vue charts guide
<template>
  <div>
    <div class="panel">
      <div class="legend">
        <span class="item"><span class="dot hollow"></span> 2019</span>
        <span class="item"><span class="dot filled"></span> 2024</span>
      </div>
    </div>

    <div id="chart">
      <apexchart
        type="ringStem"
        height="440"
        :options="chartOptions"
        :series="series"
      ></apexchart>
    </div>

    <div class="panel">
      <div class="note">
        The marks here are a custom series, registered with
        <code
          >ApexCharts.registerSeriesType('ringStem', &#123; dataType: 'rangeXY',
          renderItem &#125;)</code
        >. (For the ordinary two-dot version of this chart, ApexCharts has a
        built-in <code>chart.type: 'dumbbell'</code>; this is what to do when
        you want a mark of your own.) <code>renderItem</code> draws one stem and
        two circles per datum through the primitive <code>api</code>, and
        <code>dataType: 'rangeXY'</code> routes the
        <code>y: [start, end]</code> pair through the range path so the y-axis
        fits both bounds and the tooltip reads "start - end". Hover a marker to
        see it.
      </div>
    </div>
  </div>
</template>

<script>
import VueApexCharts from 'vue-apexcharts'
import ApexCharts from 'apexcharts'

// Marks (#11): register a reusable "ringStem" series type once. Each datum is
// a { x, y: [start, end] } pair. dataType 'rangeXY' tells ApexCharts to fold
// BOTH y-bounds into the axis scale (so the axis fits the full range, not just
// the end value) and to render the tooltip as "start - end".
//
// ApexCharts ships `chart.type: 'dumbbell'` for the ordinary version of this
// chart. What a custom type buys you is the mark itself: a hollow ring for
// where the value started and a filled dot for where it finished.
ApexCharts.registerSeriesType('ringStem', {
  dataType: 'rangeXY',
  renderItem: function (ctx) {
    var datum = ctx.datum
    var x = ctx.x
    var scales = ctx.scales
    var api = ctx.api
    var yStart = scales.y(datum.y[0])
    var yEnd = scales.y(datum.y[1])
    // connecting stem
    api.line({
      x1: x,
      y1: yStart,
      x2: x,
      y2: yEnd,
      stroke: '#d0d5dd',
      width: 4,
      lineCap: 'round',
    })
    // start marker (hollow ring) and end marker (filled)
    api.circle({
      cx: x,
      cy: yStart,
      r: 7,
      fill: '#fff',
      stroke: '#008FFB',
      strokeWidth: 3,
    })
    api.circle({ cx: x, cy: yEnd, r: 7, fill: '#00B894' })
  },
})

var ringStemData = [
  { x: 'Austin', y: [312, 498] },
  { x: 'Denver', y: [398, 545] },
  { x: 'Miami', y: [285, 610] },
  { x: 'Seattle', y: [512, 720] },
  { x: 'Boise', y: [255, 415] },
  { x: 'Raleigh', y: [268, 402] },
  { x: 'Phoenix', y: [295, 468] },
]

export default {
  components: {
    apexchart: VueApexCharts,
  },
  data: function () {
    return {
      series: [{ name: 'Price range', data: ringStemData }],
      chartOptions: {
        chart: {
          height: 440,
          type: 'ringStem',
          animations: { enabled: false },
          toolbar: { show: false },
        },
        grid: {
          padding: { left: 15, right: 15 },
          xaxis: { lines: { show: true } },
        },
        title: {
          text: 'Median home price by city: 2019 vs 2024',
          align: 'left',
        },
        subtitle: {
          text: 'A custom "ringStem" series type built with Marks (registerSeriesType)',
          align: 'left',
        },
        xaxis: {
          type: 'category',
          tooltip: { enabled: false },
        },
        yaxis: {
          min: 200,
          tickAmount: 6,
          labels: {
            formatter: function (val) {
              return '$' + Math.round(val) + 'k'
            },
          },
        },
        tooltip: {
          y: {
            formatter: function (val) {
              return '$' + val + 'k'
            },
          },
        },
      },
    }
  },
}
</script>

<style>
#chart {
  max-width: 780px;
  margin: 20px auto;
}
.panel {
  max-width: 780px;
  margin: 16px auto;
  font-family: sans-serif;
}
.legend {
  display: flex;
  gap: 22px;
  align-items: center;
  font-size: 13px;
  color: #334;
  margin: 4px 4px 0;
}
.legend .item {
  display: flex;
  gap: 7px;
  align-items: center;
}
.legend .dot {
  width: 14px;
  height: 14px;
  border-radius: 50%;
}
.legend .hollow {
  background: #fff;
  border: 3px solid #008ffb;
  box-sizing: border-box;
}
.legend .filled {
  background: #00b894;
}
.note {
  background: #f4f8ff;
  border-left: 3px solid #5b8cff;
  padding: 10px 14px;
  font-size: 13px;
  color: #234;
  margin-top: 12px;
  border-radius: 2px;
  line-height: 1.55;
}
.note code {
  background: #e6eeff;
  padding: 1px 5px;
  border-radius: 3px;
}
</style>

Ring-Stem Mark in React

Using ApexCharts with React

This Ring-Stem Mark example wires ApexCharts into React through the react-apexcharts component.

Install it with npm install react-apexcharts apexcharts, then mount the chart with <Chart type="..." options={options} series={series} />.

React charts guide
import React from 'react'
import ReactApexChart from 'react-apexcharts'
import ApexCharts from 'apexcharts'
import './styles.css'

// Marks (#11): register a reusable "ringStem" series type once. Each datum is
// a { x, y: [start, end] } pair. dataType 'rangeXY' tells ApexCharts to fold
// BOTH y-bounds into the axis scale (so the axis fits the full range, not just
// the end value) and to render the tooltip as "start - end".
//
// ApexCharts ships `chart.type: 'dumbbell'` for the ordinary version of this
// chart. What a custom type buys you is the mark itself: a hollow ring for
// where the value started and a filled dot for where it finished.
ApexCharts.registerSeriesType('ringStem', {
  dataType: 'rangeXY',
  renderItem: function (ctx) {
    var datum = ctx.datum
    var x = ctx.x
    var scales = ctx.scales
    var api = ctx.api
    var yStart = scales.y(datum.y[0])
    var yEnd = scales.y(datum.y[1])
    // connecting stem
    api.line({
      x1: x,
      y1: yStart,
      x2: x,
      y2: yEnd,
      stroke: '#d0d5dd',
      width: 4,
      lineCap: 'round',
    })
    // start marker (hollow ring) and end marker (filled)
    api.circle({
      cx: x,
      cy: yStart,
      r: 7,
      fill: '#fff',
      stroke: '#008FFB',
      strokeWidth: 3,
    })
    api.circle({ cx: x, cy: yEnd, r: 7, fill: '#00B894' })
  },
})

var ringStemData = [
  { x: 'Austin', y: [312, 498] },
  { x: 'Denver', y: [398, 545] },
  { x: 'Miami', y: [285, 610] },
  { x: 'Seattle', y: [512, 720] },
  { x: 'Boise', y: [255, 415] },
  { x: 'Raleigh', y: [268, 402] },
  { x: 'Phoenix', y: [295, 468] },
]

const ApexChart = () => {
  const [state, setState] = React.useState({
    series: [{ name: 'Price range', data: ringStemData }],
    options: {
      chart: {
        height: 440,
        type: 'ringStem',
        animations: { enabled: false },
        toolbar: { show: false },
      },
      grid: {
        padding: { left: 15, right: 15 },
        xaxis: { lines: { show: true } },
      },
      title: {
        text: 'Median home price by city: 2019 vs 2024',
        align: 'left',
      },
      subtitle: {
        text: 'A custom "ringStem" series type built with Marks (registerSeriesType)',
        align: 'left',
      },
      xaxis: {
        type: 'category',
        tooltip: { enabled: false },
      },
      yaxis: {
        min: 200,
        tickAmount: 6,
        labels: {
          formatter: function (val) {
            return '$' + Math.round(val) + 'k'
          },
        },
      },
      tooltip: {
        y: {
          formatter: function (val) {
            return '$' + val + 'k'
          },
        },
      },
    },
  })

  return (
    <div>
      <div className="panel">
        <div className="legend">
          <span className="item">
            <span className="dot hollow"></span> 2019
          </span>
          <span className="item">
            <span className="dot filled"></span> 2024
          </span>
        </div>
      </div>

      <div id="chart">
        <ReactApexChart
          options={state.options}
          series={state.series}
          type="ringStem"
          height={440}
        />
      </div>

      <div className="panel">
        <div className="note">
          The marks here are a custom series, registered with
          <code>
            ApexCharts.registerSeriesType('ringStem', &#123; dataType:
            'rangeXY', renderItem &#125;)
          </code>
          . (For the ordinary two-dot version of this chart, ApexCharts has a
          built-in
          <code>chart.type: 'dumbbell'</code>; this is what to do when you want
          a mark of your own.)
          <code>renderItem</code> draws one stem and two circles per datum
          through the primitive <code>api</code>, and{' '}
          <code>dataType: 'rangeXY'</code> routes the
          <code>y: [start, end]</code> pair through the range path so the y-axis
          fits both bounds and the tooltip reads "start - end". Hover a marker
          to see it.
        </div>
      </div>
    </div>
  )
}

export default ApexChart

Ring-Stem Mark in Angular

Using ApexCharts with Angular

This Ring-Stem Mark example wires ApexCharts into Angular through the ng-apexcharts component.

Install it with npm install ng-apexcharts apexcharts, then mount the chart with <apx-chart [series]="series" [chart]="chart"></apx-chart>.

Angular charts guide

This demo uses imperative chart updates. The generated code is a faithful Angular translation: open it in CodeSandbox to run and tweak.

import { Component, AfterViewInit, OnDestroy, ViewChild } from '@angular/core';
import {
  ChartComponent,
  ApexAxisChartSeries,
  ApexNonAxisChartSeries,
  ApexChart,
  ApexXAxis,
  ApexYAxis,
  ApexTitleSubtitle,
  ApexDataLabels,
  ApexStroke,
  ApexFill,
  ApexLegend,
  ApexTooltip,
  ApexMarkers,
  ApexPlotOptions,
  ApexResponsive,
  ApexGrid,
  ApexAnnotations,
  ApexStates,
  ApexTheme,
  NgApexchartsModule,
} from 'ng-apexcharts';

export type ChartOptions = {
  series?: ApexAxisChartSeries | ApexNonAxisChartSeries;
  chart?: ApexChart;
  xaxis?: ApexXAxis;
  yaxis?: ApexYAxis | ApexYAxis[];
  title?: ApexTitleSubtitle;
  subtitle?: ApexTitleSubtitle;
  dataLabels?: ApexDataLabels;
  stroke?: ApexStroke;
  fill?: ApexFill;
  legend?: ApexLegend;
  tooltip?: ApexTooltip;
  markers?: ApexMarkers;
  plotOptions?: ApexPlotOptions;
  responsive?: ApexResponsive[];
  grid?: ApexGrid;
  annotations?: ApexAnnotations;
  states?: ApexStates;
  theme?: ApexTheme;
  colors?: string[];
  labels?: any;
};

@Component({
  selector: 'app-chart',
  standalone: true,
  imports: [NgApexchartsModule],
  templateUrl: './chart.component.html',
})
export class AppChart implements AfterViewInit, OnDestroy {
  @ViewChild('chart') chart!: ChartComponent;
  private ringStemData: any = [
          { x: 'Austin', y: [312, 498] },
          { x: 'Denver', y: [398, 545] },
          { x: 'Miami', y: [285, 610] },
          { x: 'Seattle', y: [512, 720] },
          { x: 'Boise', y: [255, 415] },
          { x: 'Raleigh', y: [268, 402] },
          { x: 'Phoenix', y: [295, 468] },
        ];

  public chartOptions: Partial<ChartOptions> = {
          series: [{ name: 'Price range', data: this.ringStemData }],
          chart: {
            height: 440,
            type: 'ringStem',
            animations: { enabled: false },
            toolbar: { show: false },
          },
          grid: {
            padding: { left: 15, right: 15 },
            xaxis: { lines: { show: true } },
          },
          title: {
            text: 'Median home price by city: 2019 vs 2024',
            align: 'left',
          },
          subtitle: {
            text: 'A custom "ringStem" series type built with Marks (registerSeriesType)',
            align: 'left',
          },
          xaxis: {
            type: 'category',
            tooltip: { enabled: false },
          },
          yaxis: {
            min: 200,
            tickAmount: 6,
            labels: {
              formatter: (val) => {
                return '$' + Math.round(val) + 'k'
              },
            },
          },
          tooltip: {
            y: {
              formatter: (val) => {
                return '$' + val + 'k'
              },
            },
          },
        };
  ngAfterViewInit() {
    (window as any).ApexCharts.setLicense('APEX-eyJleHBpcnlEYXRlIjoiMjEyNi0wNy0wNCIsImlzc3VlRGF0ZSI6IjIwMjYtMDctMjgiLCJwbGFuIjoicHJlbWl1bSIsImRvbWFpbnMiOlsiYXBleGNoYXJ0cy5jb20iLCIxMjcuMC4wLjEiLCJsb2NhbGhvc3QiXSwic2lnIjoieVBmb1VCc0Z3TU9ZdUEyaEZkR0I2Y1FtZ0JITUtXcVdJSjB2NVRESXRZbFR3eDJMUmh6R2x0RUc3VXJ4X0s3b25ZMWRZb2Z2VGItN01ydFYyNDVyOWcifQ==');
    ApexCharts.registerSeriesType('ringStem', {
            dataType: 'rangeXY',
            renderItem: (ctx) => {
              var datum = ctx.datum
              var x = ctx.x
              var scales = ctx.scales
              var api = ctx.api
              var yStart = scales.y(datum.y[0])
              var yEnd = scales.y(datum.y[1])
              // connecting stem
              api.line({
                x1: x,
                y1: yStart,
                x2: x,
                y2: yEnd,
                stroke: '#d0d5dd',
                width: 4,
                lineCap: 'round',
              })
              // start marker (hollow ring) and end marker (filled)
              api.circle({
                cx: x,
                cy: yStart,
                r: 7,
                fill: '#fff',
                stroke: '#008FFB',
                strokeWidth: 3,
              })
              api.circle({ cx: x, cy: yEnd, r: 7, fill: '#00B894' })
            },
          })
  }

  ngOnDestroy() {
    // no cleanup needed
  }
}